Game Develop Core: gd::ChangesNotifier Class Reference

| Game Develop Core Core library for developing platforms and tools compatible with Game Develop.

- Main Page
- Modules
- Classes

- Class List
- Class Index
- Class Hierarchy

All Classes Files Functions Variables Typedefs Enumerations Macros Groups Pages
List of all members
gd::ChangesNotifier Class Reference
IDE Classes ( Classes to be used to implement a development environment )

Allows implementations to do specific work when some changes have been made in the IDE. More...

`#include <ChangesNotifier.h>`

## Public Member Functions

Layouts
Members functions called by the IDE so as to notify changes have been made
virtual void | OnLayoutAdded (gd::Project &project, gd::Layout &layout) const
| Called when a layout was added to a project. More...
virtual void | OnLayoutRenamed (gd::Project &project, gd::Layout &layout, const std::string &oldName) const
| Called when a layout was renamed. More...
virtual void | OnLayoutDeleted (gd::Project &project, const std::string deletedLayout) const
| Called when a layout was removed from a project. More...
virtual void | OnVariablesModified (gd::Project &project, gd::Layout *layout=NULL) const
| Called when (layout or global) variables were modified. More...
External Layouts
Members functions called by the IDE so as to notify changes have been made
virtual void | OnExternalLayoutAdded (gd::Project &project, gd::ExternalLayout &layout) const
| Called when an external layout was added to a project. More...
virtual void | OnExternalLayoutRenamed (gd::Project &project, gd::ExternalLayout &layout, const std::string &oldName) const
| Called when an external layout was renamed. More...
virtual void | OnExternalLayoutDeleted (gd::Project &project, const std::string deletedLayout) const
| Called when an external layout was removed from a project. More...
External events
Members functions called by the IDE so as to notify changes have been made
virtual void | OnExternalEventsAdded (gd::Project &project, gd::ExternalEvents &events) const
| Called when external events were added to a project. More...
virtual void | OnExternalEventsRenamed (gd::Project &project, gd::ExternalEvents &events, const std::string &oldName) const
| Called when external events were renamed. More...
virtual void | OnExternalEventsDeleted (gd::Project &project, const std::string deletedLayout) const
| Called when external events were removed from a project. More...
Events
Members functions called by the IDE so as to notify changes have been made
virtual void | OnEventsModified (gd::Project &project, gd::Layout &layout, bool indirectChange=false, std::string sourceOfTheIndirectChange="") const
| Called when the events of a layout have been modified. More...
virtual void | OnEventsModified (gd::Project &project, gd::ExternalEvents &events, bool indirectChange=false, std::string sourceOfTheIndirectChange="") const
| Called when some external events have been modified. More...
Objects and automatisms notifications
Members functions called by the IDE so as to notify changes have been made
virtual void | OnObjectEdited (gd::Project &project, gd::Layout *layout, gd::Object &object) const
| Called when an object has been edited. More...
virtual void | OnObjectAdded (gd::Project &project, gd::Layout *layout, gd::Object &object) const
| Called when an object has been edited. More...
virtual void | OnObjectRenamed (gd::Project &project, gd::Layout *layout, gd::Object &object, const std::string &oldName) const
| Called when an object has been renamed. More...
virtual void | OnObjectsDeleted (gd::Project &project, gd::Layout *layout, const std::vector< std::string > &deletedObjects) const
| Called when one or more objects have been deleted. More...
virtual void | OnObjectVariablesChanged (gd::Project &project, gd::Layout *layout, gd::Object &object) const
| Called when an object's variables have been changed. More...
virtual void | OnAutomatismEdited (gd::Project &project, gd::Layout *layout, gd::Object &object, gd::Automatism &automatism) const
| Called when an automatism have been edited. More...
virtual void | OnAutomatismAdded (gd::Project &project, gd::Layout *layout, gd::Object &object, gd::Automatism &automatism) const
| Called when an automatism have been added. More...
virtual void | OnAutomatismRenamed (gd::Project &project, gd::Layout *layout, gd::Object &object, gd::Automatism &automatism, const std::string &oldName) const
| Called when an automatism have been renamed. More...
virtual void | OnAutomatismDeleted (gd::Project &project, gd::Layout *layout, gd::Object &object, const std::string &automatismName) const
| Called when an automatism have been deleted. More...
virtual void | OnObjectGroupAdded (gd::Project &project, gd::Layout *layout, const std::string &groupName) const
| Called when a group have been added. More...
virtual void | OnObjectGroupEdited (gd::Project &project, gd::Layout *layout, const std::string &groupName) const
| Called when a group has been edited. More...
virtual void | OnObjectGroupRenamed (gd::Project &project, gd::Layout *layout, const std::string &groupName, const std::string &oldName) const
| Called when a group have been renamed. More...
virtual void | OnObjectGroupDeleted (gd::Project &project, gd::Layout *layout, const std::string &groupName) const
| Called when a group have been deleted. More...
virtual void | OnResourceModified (gd::Project &project, const std::string &resourceName) const
| Called when a resource have been added/removed/modified. More...

## Detailed Description

Allows implementations to do specific work when some changes have been made in the IDE.

For example, the C++ Platform triggers events recompilation when some changes are made.

## Member Function Documentation

virtual void gd::ChangesNotifier::OnAutomatismAdded | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | gd::Object & | object,
|  | gd::Automatism & | automatism
| ) |  | const

inlinevirtual

Called when an automatism have been added.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  object | Related object
  automatism | Automatism

virtual void gd::ChangesNotifier::OnAutomatismDeleted | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | gd::Object & | object,
|  | const std::string & | automatismName
| ) |  | const

inlinevirtual

Called when an automatism have been deleted.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  object | Related object
  automatismName | The name of the automatism removed

virtual void gd::ChangesNotifier::OnAutomatismEdited | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | gd::Object & | object,
|  | gd::Automatism & | automatism
| ) |  | const

inlinevirtual

Called when an automatism have been edited.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  object | Related object
  automatism | Automatism

virtual void gd::ChangesNotifier::OnAutomatismRenamed | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | gd::Object & | object,
|  | gd::Automatism & | automatism,
|  | const std::string & | oldName
| ) |  | const

inlinevirtual

Called when an automatism have been renamed.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  object | Related object
  automatism | Automatism
  oldName | Automatism old name

virtual void gd::ChangesNotifier::OnEventsModified | ( | gd::Project & | project,
|  | gd::Layout & | layout,
|  | bool | indirectChange = `false`,
|  | std::string | sourceOfTheIndirectChange = `""`
| ) |  | const

inlinevirtual

Called when the events of a layout have been modified.

Parameters

  project | Related project
  layout | Layout
  indirectChange | true if the changes have been made "indirectly" by modifying for example some external events used by a layout
  sourceOfTheIndirectChange | if indirectChange == true, contains the name of the external events which trigger the change.

virtual void gd::ChangesNotifier::OnEventsModified | ( | gd::Project & | project,
|  | gd::ExternalEvents & | events,
|  | bool | indirectChange = `false`,
|  | std::string | sourceOfTheIndirectChange = `""`
| ) |  | const

inlinevirtual

Called when some external events have been modified.

Parameters

  project | Related project
  events | External events
  indirectChange | true if the changes have been made "indirectly" by modifying for example some external events used by a layout
  sourceOfTheIndirectChange | if indirectChange == true, contains the name of the external events which trigger the change.

virtual void gd::ChangesNotifier::OnExternalEventsAdded | ( | gd::Project & | project,
|  | gd::ExternalEvents & | events
| ) |  | const

inlinevirtual

Called when external events were added to a project.

Parameters

  project | Related project
  events | External events

virtual void gd::ChangesNotifier::OnExternalEventsDeleted | ( | gd::Project & | project,
|  | const std::string | deletedLayout
| ) |  | const

inlinevirtual

Called when external events were removed from a project.

Parameters

  project | Related project
  deletedLayout | Name of the removed external events

virtual void gd::ChangesNotifier::OnExternalEventsRenamed | ( | gd::Project & | project,
|  | gd::ExternalEvents & | events,
|  | const std::string & | oldName
| ) |  | const

inlinevirtual

Called when external events were renamed.

Parameters

  project | Related project
  events | External events
  oldName | Old name of the external events

virtual void gd::ChangesNotifier::OnExternalLayoutAdded | ( | gd::Project & | project,
|  | gd::ExternalLayout & | layout
| ) |  | const

inlinevirtual

Called when an external layout was added to a project.

Parameters

  project | Related project
  layout | External layout

virtual void gd::ChangesNotifier::OnExternalLayoutDeleted | ( | gd::Project & | project,
|  | const std::string | deletedLayout
| ) |  | const

inlinevirtual

Called when an external layout was removed from a project.

Parameters

  project | Related project
  deletedLayout | Name of the removed external layout

virtual void gd::ChangesNotifier::OnExternalLayoutRenamed | ( | gd::Project & | project,
|  | gd::ExternalLayout & | layout,
|  | const std::string & | oldName
| ) |  | const

inlinevirtual

Called when an external layout was renamed.

Parameters

  project | Related project
  layout | External layout
  oldName | Old name of the external layout

virtual void gd::ChangesNotifier::OnLayoutAdded | ( | gd::Project & | project,
|  | gd::Layout & | layout
| ) |  | const

inlinevirtual

Called when a layout was added to a project.

Parameters

  project | Related project
  layout | Layout

virtual void gd::ChangesNotifier::OnLayoutDeleted | ( | gd::Project & | project,
|  | const std::string | deletedLayout
| ) |  | const

inlinevirtual

Called when a layout was removed from a project.

Parameters

  project | Related project
  deletedLayout | Name of the removed layout

virtual void gd::ChangesNotifier::OnLayoutRenamed | ( | gd::Project & | project,
|  | gd::Layout & | layout,
|  | const std::string & | oldName
| ) |  | const

inlinevirtual

Called when a layout was renamed.

Parameters

  project | Related project
  layout | Layout
  oldName | Old name of the layout

virtual void gd::ChangesNotifier::OnObjectAdded | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | gd::Object & | object
| ) |  | const

inlinevirtual

Called when an object has been edited.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  object | Object

virtual void gd::ChangesNotifier::OnObjectEdited | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | gd::Object & | object
| ) |  | const

inlinevirtual

Called when an object has been edited.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  object | Object

virtual void gd::ChangesNotifier::OnObjectGroupAdded | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | const std::string & | groupName
| ) |  | const

inlinevirtual

Called when a group have been added.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  groupName | The name of the group added

virtual void gd::ChangesNotifier::OnObjectGroupDeleted | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | const std::string & | groupName
| ) |  | const

inlinevirtual

Called when a group have been deleted.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  groupName | The name of the group removed

virtual void gd::ChangesNotifier::OnObjectGroupEdited | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | const std::string & | groupName
| ) |  | const

inlinevirtual

Called when a group has been edited.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  groupName | The name of the group modified

virtual void gd::ChangesNotifier::OnObjectGroupRenamed | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | const std::string & | groupName,
|  | const std::string & | oldName
| ) |  | const

inlinevirtual

Called when a group have been renamed.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  groupName | The name of the group modified
  oldName | Group's old name

virtual void gd::ChangesNotifier::OnObjectRenamed | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | gd::Object & | object,
|  | const std::string & | oldName
| ) |  | const

inlinevirtual

Called when an object has been renamed.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  object | Object
  oldName | Object old name

virtual void gd::ChangesNotifier::OnObjectsDeleted | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | const std::vector< std::string > & | deletedObjects
| ) |  | const

inlinevirtual

Called when one or more objects have been deleted.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  objectName | The name of the object removed

virtual void gd::ChangesNotifier::OnObjectVariablesChanged | ( | gd::Project & | project,
|  | gd::Layout * | layout,
|  | gd::Object & | object
| ) |  | const

inlinevirtual

Called when an object's variables have been changed.

Parameters

  project | Related project
  layout | Related layout ( can be NULL )
  object | Object

virtual void gd::ChangesNotifier::OnResourceModified | ( | gd::Project & | project,
|  | const std::string & | resourceName
| ) |  | const

inlinevirtual

Called when a resource have been added/removed/modified.

Parameters

  project | Related project
  automatismName | The name of the resource which have been modified

virtual void gd::ChangesNotifier::OnVariablesModified | ( | gd::Project & | project,
|  | gd::Layout * | layout = `NULL`
| ) |  | const

inlinevirtual

Called when (layout or global) variables were modified.

Parameters

  project | Related project
  layout | Layout owning the variables, if applicable

The documentation for this class was generated from the following file:

- ChangesNotifier.h